package com.xunmei.system.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.xunmei.common.core.utils.DateUtils;
import com.xunmei.common.core.web.page.TableDataInfo;
import com.xunmei.system.api.domain.SysLogininfor;
import com.xunmei.system.api.domain.SysOperLog;
import com.xunmei.system.domain.SysNotice;
import com.xunmei.system.mapper.SysNoticeMapper;
import com.xunmei.system.mapper.SysOperLogMapper;
import com.xunmei.system.service.ISysOperLogService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 操作日志 服务层处理
 *
 * @author xunmei
 */
@Service
public class SysOperLogServiceImpl extends ServiceImpl<SysOperLogMapper, SysOperLog> implements ISysOperLogService {
    @Autowired
    private SysOperLogMapper operLogMapper;

    @Override
    public TableDataInfo<SysOperLog> selectPage(SysOperLog operLog) {
        Page<SysOperLog> page;
        if (operLog.getPageNum() != null && operLog.getPageSize() != null) {
            page = new Page<>(operLog.getPageNum(), operLog.getPageSize());
        } else {
            page = new Page<>();
        }
        QueryWrapper<SysOperLog> where = new QueryWrapper<>(operLog);

        Object beginTime = operLog.getParams().get("beginTime");
        Object endTime = operLog.getParams().get("endTime");
        if(beginTime != null){
            where.lambda().ge(SysOperLog::getOperTime, DateUtils.parseDate(beginTime));
        }
        if(endTime != null){
            where.lambda().le(SysOperLog::getOperTime, DateUtils.parseDate(endTime));
        }

        baseMapper.selectPage(page, where);
        return TableDataInfo.build(page);
    }

    /**
     * 新增操作日志
     *
     * @param operLog 操作日志对象
     * @return 结果
     */
    @Override
    public int insertOperlog(SysOperLog operLog) {
        return operLogMapper.insertOperlog(operLog);
    }

    /**
     * 查询系统操作日志集合
     *
     * @param operLog 操作日志对象
     * @return 操作日志集合
     */
    @Override
    public List<SysOperLog> selectOperLogList(SysOperLog operLog) {
        return operLogMapper.selectOperLogList(operLog);
    }

    /**
     * 批量删除系统操作日志
     *
     * @param operIds 需要删除的操作日志ID
     * @return 结果
     */
    @Override
    public int deleteOperLogByIds(Long[] operIds) {
        return operLogMapper.deleteOperLogByIds(operIds);
    }

    /**
     * 查询操作日志详细
     *
     * @param operId 操作ID
     * @return 操作日志对象
     */
    @Override
    public SysOperLog selectOperLogById(Long operId) {
        return operLogMapper.selectOperLogById(operId);
    }

    /**
     * 清空操作日志
     */
    @Override
    public void cleanOperLog() {
        operLogMapper.cleanOperLog();
    }
}
